/************************************************************************************
The code is designed and produced by MDY Science and Education Co., Ltd, which has the entire ownership. It is only for personal learning, which cannot be used for commercial or profit-making purposes without permission.

    MDY's Mission: Develop Chip Talents and Realize National Chip Dream.

    We sincerely hope that our students can learn the real IC / FPGA code through our standard and rigorous code.

    For more FPGA learning materials, please visit the Forum: http://fpgabbs.com/ and official website: http://www.mdy-edu.com/index.html 

    *************************************************************************************/

module  mdykeyClock(
    clk    ,
    rst_n  ,
    key    ,
    segment,
    seg_sel
);

parameter   COUNT_TIME      =   23'd500_0000;
parameter   DELAY_TIME      =   10000       ;
parameter   SEG_WID         =   8           ;
parameter   SEG_SEL         =   6           ;

parameter   KEY_S           =   4           ;
parameter   KEY_W           =   3           ;

input                   clk         ;
input                   rst_n       ;
input   [ 2:0]          key         ;
output  [ 7:0]          segment     ;
output  [ 6:0]          seg_sel     ;

wire    [ 2:0]          key_vld     ;
wire    [23:0]          segment_data;
wire    [ 3:0]          cnt2        ;
wire    [ 3:0]          cnt3        ;
wire    [ 3:0]          cnt4        ;
wire    [ 3:0]          cnt5        ;
wire    [ 3:0]          cnt6        ;
wire    [ 3:0]          cnt7        ;


             key_module  uut0(
                .clk     (clk    ),
                .rst_n   (rst_n  ),
                .key_in  (key    ),
                .key_vld (key_vld)
             );


             time_data  uut1(
                .clk      (clk    ), 
                .rst_n    (rst_n  ), 
                .key_vld  (key_vld), 
                .cnt2     (cnt2   ), 
                .cnt3     (cnt3   ), 
                .cnt4     (cnt4   ), 
                .cnt5     (cnt5   ), 
                .cnt6     (cnt6   ), 
                .cnt7     (cnt7   ) 

             );


             seg_disp  uut2(
                 .clk          (clk                          ), 
                 .rst_n        (rst_n                        ), 
                 .segment      (segment                      ), 
                 .seg_sel      (seg_sel                      ),
                 .segment_data ({cnt7,cnt6,cnt5,cnt4,cnt3,cnt2}) 

             );


endmodule




